<script>
import { mapGetters, mapState } from 'vuex';

export default {
  name: `anim-rig-public-lib-card`,
  props: {
    lib: { type: Object, required: true },
    isAnimLead: { type: Boolean, required: true },
  },
  data() {
    return {
      editing: false,
      editedLibName: ``,
      showUnpublishModal: false,
      showDeleteModal: false,
      showReviveModal: false,
    }
  },
  computed: {
    ...mapGetters('projects', [ 'isWriter' ]),
    ...mapState({
      username: (state) => state.users.currentUser.username,
      isAdmin: (state) => state.users.currentUser.roles.includes(`admin`),
    }),
    isInactive() {
      return !this.lib.active;
    },
    iAmWriter() {
      return this.isWriter(this.username);
    },
  },
  methods: {
    toggleEdit() {
      this.editedLibName = this.lib.name;
      this.editing = true;
      setTimeout(() => {
        this.$refs[`edit-lib-name`].focus();
      }, 100);
    },
    setLibraryName() {
      if (this.editedLibName !== `` && this.editedLibName !== this.lib.name) {
        this.$emit(`set-name`, this.editedLibName);
      }
      this.editedLibName = ``;
      this.editing = false;
    },
    toggleLibraryFavorite() {
      this.$emit(`toggle-favorite`, !this.lib.favorite);
    },
    closeUnpublishModal() {
      this.showUnpublishModal = false;
    },
    closeDeleteModal() {
      this.showDeleteModal = false;
    },
    closeReviveModal() {
      this.showReviveModal = false;
    },
    unpublishLibrary() {
      this.$emit(`unpublish`);
      this.closeUnpublishModal();
    },
    deleteLibrary() {
      this.$emit(`delete`);
      this.closeDeleteModal();
    },
    reviveLibrary() {
      this.$emit(`revive`);
      this.closeReviveModal();
    },
  },
}
</script>

<template>
  <cbr-card
    :to="(editing) ? null : { path: localePath(`/anim-rig/${lib.name}`), query: $route.query }"
    :disabled="isInactive"
    :style="{ 'margin-left': `${lib.indent * 20}px` }"
    class="card"
  >
    <cbr-modal v-model="showUnpublishModal"
              :title="$t(`anim-rig.unpublish-lib.title`)"
              :onCancel="closeUnpublishModal"
              :onConfirm="unpublishLibrary"
              :confirm-text="$t(`common.unpublish`)">
      {{ $t(`anim-rig.unpublish-lib.content`, { name: lib.name }) }}
    </cbr-modal>
    <cbr-modal v-model="showDeleteModal"
              :title="$t(`anim-rig.delete-lib.title`)"
              :onCancel="closeDeleteModal"
              :onConfirm="deleteLibrary"
              :confirm-text="$t(`common.delete`)"
              confirm-color="error">
      {{ $t(`anim-rig.delete-lib.content`, { name: lib.name }) }}
    </cbr-modal>
    <cbr-modal v-model="showReviveModal"
              :title="$t(`anim-rig.revive-lib.title`)"
              :onCancel="closeReviveModal"
              :onConfirm="reviveLibrary"
              :confirm-text="$t(`common.revive`)">
      {{ $t(`anim-rig.revive-lib.content`, { name: lib.name }) }}
    </cbr-modal>
    <v-row no-gutters align="center">
      <v-btn icon class="mr-2" @click.stop="toggleLibraryFavorite">
        <v-icon>
          {{ lib.favorite ? `mdi-star` : `mdi-star-outline` }}
        </v-icon>
      </v-btn>
      <div class="text-subcaption" v-if="!editing">{{ lib.name }}</div>
      <v-text-field
        v-else
        type="text"
        ref="edit-lib-name"
        v-model="editedLibName"
        @blur="setLibraryName"
        @keypress.enter="setLibraryName"
        dense
        hide-details
      />
      <v-spacer />
      <v-row no-gutters class="flex-grow-0" align="center">
        <span class="text--disabled">{{ $t(`anim-rig.owned-by`, { owner: lib.owner }) }}</span>
        <v-btn
          v-if="iAmWriter && isAnimLead"
          icon
          @click.stop="toggleEdit"
        >
          <v-icon>mdi-pencil-outline</v-icon>
        </v-btn>
        <v-btn
          v-if="isAdmin"
          icon
          @click.stop="showUnpublishModal = true"
        >
          <v-icon>mdi-lock</v-icon>
        </v-btn>
        <v-btn
          v-if="isAdmin && !isInactive"
          icon
          @click.stop="showDeleteModal = true"
        >
          <v-icon>mdi-delete</v-icon>
        </v-btn>
        <v-btn
          v-else-if="isAdmin"
          icon
          @click.stop="showReviveModal = true"
        >
          <v-icon>mdi-backup-restore</v-icon>
        </v-btn>
      </v-row>
    </v-row>
  </cbr-card>
</template>
